import binascii, os, sys, string

from convert import hotshot
from d64 import d64

magname = "hotshot"
for magpostfix in ["04", "05", "06", "07", "08", "09", "10", "11", "12"] :
    filename = magname + magpostfix

    print "Processing", filename
    f = open(filename + ".d64", "rb")
    disk = f.read()
    f.close()

    img = d64.D64image(disk)
    dir = img.get_dir()
    for entry in dir :
        filename = entry[0]
        outfilename = ""
        if magpostfix in ["04", "05", "06", "07", "08", "09", "10"] and filename[15] in string.digits :
            outfilename = magname + "-" + magpostfix + "-" + filename[15] + ".txt"
        if magpostfix in ["11", "12"] and filename[0] == "H" and filename[1] in string.digits :
            outfilename = magname + "-" + magpostfix + "-" + filename[1] + ".txt"
        if outfilename :
            print filename
            data = img.get_file_by_name(filename)
            if magpostfix == "04" :
                controlbyte = 0xde
            else :
                controlbyte = 0x9e
            data = hotshot.Unpacker(data, controlbyte).unpack()
            data = data[0:-8]
            data = data.rstrip(data[-1])
            data = hotshot.translate(data)
            data = hotshot.webready(data)
            of = open(outfilename, "wb")
            of.write(data)
            of.close()

