import binascii, os, sys

from convert import propaganda
from d64 import d64

def webready(data) :
    data = data.replace("&", "&amp;")
    data = data.replace("<", "&lt;")
    data = data.replace(">", "&gt;")
    
    data = "<pre>" + data + "</pre>"
    return data

magname = "propaganda"
for magnumber in xrange(16, 26) :
    magnum = "%02d" % magnumber

    print "Processing", magname
    f = open(magname + magnum + ".d64", "rb")
    disk = f.read()
    f.close()

    img = d64.D64image(disk)
    dir = img.get_dir()
    for entry in dir :
        filename = entry[0]
        if filename[1] == "." and ord(filename[0]) >= ord("A") and ord(filename[0]) <= ord("Z") :
            print filename
            data = img.get_file_by_name(filename)
            data = data[5:]
            data = propaganda.remove_headers(data)
            data = propaganda.expand(data)
            data = propaganda.translate(data)

            data = webready(data)
            
            of = open(magname + "-" + magnum + "-" + filename[0] + ".txt", "wb")
            of.write(data)
            of.close()
