#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, os, sys, string

from convert import vandalism_news
from d64 import d64

d64name = "vandalism_news"
magname = "vandalism news"
for magnumber in xrange(6, 8) :
    magnum = "%02d" % magnumber

    for diskside in "@abcd" :
        if diskside == "@" :
            diskside = ""

        fname = d64name + magnum + diskside + ".d64"
        if not os.path.isfile(fname) :
            continue
            
        print "Processing", magname + magnum + diskside
        f = open(d64name + magnum + diskside + ".d64", "rb")
        disk = f.read()
        f.close()

        img = d64.D64image(disk)
        dir = img.get_dir()
        for entry in dir :
            filename = entry[0]
            if filename[0] in string.digits and filename[1] in string.digits :
                if magnumber == 7 and filename[0:2] == "01" :
                    continue
                print filename
                data = img.get_file_by_name(filename)
                data = vandalism_news.Unpacker(data).unpack()
                if data[0x1d01] == "\x00" :
                    data = data[0x1d01:]
                else :
                    data = data[0x2001:]
                data = vandalism_news.translate(data)
                fname = magname + "-" + magnum + "-" + filename[0:2] + ".txt"
                if os.path.isfile(fname) :
                    print "File exists", fname
                    fname += "_"
                of = open(fname, "wb")
                of.write(data)
                of.close()
