#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, os, sys, string

from convert import vandalism_news
from d64 import d64

d64name = "vandalism_news"
magname = "vandalism news"
for magnumber in xrange(8, 10) :
    magnum = "%02d" % magnumber

    for diskside in "@abcd" :
        if diskside == "@" :
            diskside = ""

        fname = d64name + magnum + diskside + ".d64"
        if not os.path.isfile(fname) :
            continue
            
        print "Processing", magname + magnum + diskside
        f = open(d64name + magnum + diskside + ".d64", "rb")
        disk = f.read()
        f.close()

        img = d64.D64image(disk)
        dir = img.get_dir()
        chaptercount = 1
        for entry in dir :
            filename = entry[0]
            if filename[15] == "." :
                print filename
                data = img.get_file_by_name(filename)
                blocks = vandalism_news.Unpacker2(data).unpack()
                for data in blocks :
                    if data[0] != "\x4c" :
                        break
                data = data[1:]
                
                newdata = ""
                for i in xrange(0, len(data), 0x200) :
                    newdata += data[i:i+0x1e0]
                data = newdata
                data = vandalism_news.translate(data)
                fname = magname + "-" + magnum + "-" + ("%02d" % chaptercount) + "-" +  filename.rstrip(".").lower() + ".txt"
                if os.path.isfile(fname) :
                    print "File exists", fname
                    fname += "_"
                of = open(fname, "wb")
                of.write(data)
                of.close()
                chaptercount += 1
