#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, os, sys, string

from convert import vandalism_news
from d64 import d64

table = "_abcdefghijklmnopqrstuvwxyz[]^<" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ*__--" + \
        " !\"#$%&'() +,-./0123456789:;<=>?"

def convert_txt(data) :
    
    i = 0
    outdata = ""
    while i < len(data) :
        char_ord = ord(data[i])
        
        if char_ord == 0xff :
            #outdata += "<color %d>" % ord(data[i+1])
            i += 2
        elif char_ord == 0x00 :
            outdata += "\n"
            i += 1
        elif char_ord == 0x80 :
            outdata += "  "
            i += 1
        elif char_ord > 0x80 :
            count = ord(data[i+1])
            outdata += table[char_ord-0x80] * count
            if table[char_ord-0x80] == "_" :
                outdata += "<%x>" % (char_ord - 0x80)
            i += 2
        else :
            outdata += table[char_ord]
            if table[char_ord] == "_" :
                outdata += "<%x>" % char_ord
                #print outdata[-160:]
                #sys.exit()
                
            i += 1
        
    return outdata
        
    
d64name = "vandalism_news"
magname = "vandalism news"
for magnumber in xrange(21, 27) :
    magnum = "%02d" % magnumber

    for diskside in "@abcd" :
        if diskside == "@" :
            diskside = ""

        fname = d64name + magnum + diskside + ".d64"
        if not os.path.isfile(fname) :
            continue
            
        print "Processing", magname + magnum + diskside
        f = open(d64name + magnum + diskside + ".d64", "rb")
        disk = f.read()
        f.close()

        img = d64.D64image(disk)
        dir = img.get_dir()
        for entry in dir :
            filename = entry[0]
            if filename[0] in "01234" and filename[1] in string.digits and filename[2] not in string.digits :
                print filename
                data = img.get_file_by_name(filename)
                data = vandalism_news.Unpacker2(data, True).unpack()[0]
                start_address = ord(data[0]) + ord(data[256]) * 256 - 0x4000
                data = convert_txt(data[start_address:])
                fname = magname + "-" + magnum + "-" + filename[0:2] + ".txt"
                if os.path.isfile(fname) :
                    print "File exists", fname
                    fname += "_"
                of = open(fname, "wb")
                of.write(data)
                of.close()
