import binascii, os, sys, string

from convert import vandalism_news
from d64 import d64

d64name = "vandalism_news"
magname = "vandalism news"
for magnumber in xrange(27, 50) :
    magnum = "%02d" % magnumber

    for diskside in "@abcd" :
        if diskside == "@" :
            diskside = ""

        fname = d64name + magnum + diskside + ".d64"
        if not os.path.isfile(fname) :
            continue
            
        print "Processing", magname + magnum + diskside
        f = open(d64name + magnum + diskside + ".d64", "rb")
        disk = f.read()
        f.close()

        img = d64.D64image(disk)
        dir = img.get_dir()
        for entry in dir :
            filename = entry[0]
            if filename[0] in "01234" and filename[1] in string.digits and filename[2] not in string.digits :
                print filename
                data = img.get_file_by_name(filename)
                data = vandalism_news.Unpacker2(data).unpack()
                data = data[0x100:]
                data = vandalism_news.Translator(data).translate()
                fname = magname + "-" + magnum + "-" + filename[0:2] + ".txt"
                if os.path.isfile(fname) :
                    print "File exists", fname
                    fname += "_"
                    #sys.exit()
                of = open(fname, "wb")
                of.write(data)
                of.close()
