import binascii, os, sys, string

from convert import worldnews
from d64 import d64

for magpostfix in ["09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20"] :
    magname = "worldnews" + magpostfix

    print "Processing", magname
    f = open(magname + ".d64", "rb")
    disk = f.read()
    f.close()

    img = d64.D64image(disk)
    dir = img.get_dir()
    for entry in dir :
        filename = entry[0]
        if filename[0] in "012345678" and filename[1] not in string.digits :
            if filename[0:2] == "0 " :
                continue
            print filename
            data = img.get_file_by_name(filename)
            data = worldnews.Unpacker(data).unpack()
            if magpostfix not in ["14"] :
                data = data[0:16].replace("\x00", " ") + (24 * " ") + data[16:]
            data = worldnews.translate(data)
            
            of = open(magname + "-" + filename[0] + ".txt", "wb")
            of.write(data)
            of.close()
