#!/usr/bin/python
# -*- coding: iso-8859-15 -*-

import binascii, sys

def webready(data) :
    data = data.replace("&", "&amp;")
    data = data.replace("<", "&lt;")
    data = data.replace(">", "&gt;")
    
    data = "<pre>" + data + "</pre>"
    return data

def unpack(data, offsetaddr) :
    outdata = ""
    i = 0
    while i < len(data) :
        if data[i] == "\xbf" :
            if data[i + 1] == "\x00" :
                outdata += "\xbf"
                i += 2
            else :
                count = ord(data[i + 1])
                pos = (ord(data[i + 2]) * 256 + ord(data[i + 3])) - offsetaddr
                #print binascii.b2a_hex(data[i:i+4])
                #print "count", hex(count), "pos", hex(pos)
                
                for j in xrange(count) :
                    outdata += outdata[pos + j]
                    #print binascii.b2a_hex(outdata[pos + j]),
                #print
                i += 4
        else :
            outdata += data[i]
            i += 1
            
    return outdata

table = "_abcdefghijklmnopqrstuvwxyz" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" + \
        "_ABCDEFGHIJKLMNOPQRSTUVWXYZ" + \
        " !\"#$%&'()*+,-./0123456789:;<=>?" 
                  
def translate(data) :    
    outdata = ""
    line = ""
    for i in xrange(len(data)) :
        char = ord(data[i])
        line += table[char]
       
        if i % 40 == 39 :
            outdata += line.rstrip() + "\n"
            line = ""
            
    return outdata