class Unpacker(object) :
    def __init__(self, data) :
        self.data = data
        self.control1 = ord(data[0x3f])
        self.control2 = ord(data[0x43])
        self.control3 = ord(data[0x47])
        self.control4 = ord(data[0x4c])
        self.index = 0x8e
        #print hex(self.control1), hex(self.control2), hex(self.control3), hex(self.control4)
        
    def get_byte(self) :
        if self.index == len(self.data) :
            return False
        byte = ord(self.data[self.index])
        self.index += 1
        return byte
        
    def unpack(self) :
        block = ""
        while True :
            byte = self.get_byte()
            if byte == False :
                break
            if byte == self.control1 :
                count = self.get_byte()
                block += "\x00" * count            
            elif byte == self.control2 :
                repeatbyte = self.get_byte()
                block += chr(repeatbyte) * 3
            elif byte == self.control3 :
                block += "\x00" * 2
            elif byte == self.control4 :
                repeatbyte = self.get_byte()
                count = self.get_byte()
                block += chr(repeatbyte) * (count + 1)
            else :
                block += chr(byte)
                        
        return block