import binascii, os, sys, string

from convert import brutalrecall
from d64 import d64

magname = "brutal recall"
for magpostfix in ["10", "11a", "11b", "12"] :
    outfilename = magname + magpostfix

    print "Processing", outfilename
    f = open("brutalrecall" + magpostfix + ".d64", "rb")
    disk = f.read()
    f.close()

    img = d64.D64image(disk)
    dir = img.get_dir()
    for entry in dir :
        filename = entry[0]
        if filename[0] in string.letters and filename[1] in string.digits :
            if magpostfix == "10" and filename[0:2] == "B2" :
                continue
            print filename
            data = img.get_file_by_name(filename)
            data = data[2:]
            data = brutalrecall.unpack(data, 0x8000)
            data = brutalrecall.translate(data)
            data = brutalrecall.webready(data)
            fname = magname + "-" + magpostfix[0:2] + "-" + filename[0:2] + ".txt"
            if os.path.isfile(fname) :
                print "File exists", fname
                sys.exit()
            of = open(fname, "wb")
            of.write(data)
            of.close()
