import binascii, os, sys, string

from convert import hotshot
from d64 import d64

magname = "hotshot"
for magpostfix in ["13", "14", "15", "16", "17", "18", "19"] :
    filename = magname + magpostfix

    print "Processing", filename
    f = open(filename + ".d64", "rb")
    disk = f.read()
    f.close()

    img = d64.D64image(disk)
    dir = img.get_dir()
    for entry in dir :
        filename = entry[0]
        if filename[0] == "H" and filename[1] in string.digits :
            print filename
            data = img.get_file_by_name(filename)
            controlbyte = 0x1b
            data = hotshot.Unpacker(data, controlbyte).unpack()
            data = data[0:-8]
            data = data.rstrip(data[-1])
            data = hotshot.translate2(data)
            data = hotshot.webready(data)
            of = open(magname + "-" + magpostfix + "-" + filename[1] + ".txt", "wb")
            of.write(data)
            of.close()

