#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
import binascii, os, sys, string

from convert import vandalism_news
from d64 import d64

d64name = "vandalism_news"
magname = "vandalism news"
for magnumber in xrange(1, 5) :
    magnum = "%02d" % magnumber

    for diskside in "@abcd" :
        if diskside == "@" :
            diskside = ""

        fname = d64name + magnum + diskside + ".d64"
        if not os.path.isfile(fname) :
            continue
            
        print "Processing", magname + magnum + diskside
        f = open(d64name + magnum + diskside + ".d64", "rb")
        disk = f.read()
        f.close()

        img = d64.D64image(disk)
        dir = img.get_dir()
        for entry in dir :
            filename = entry[0]
            if filename[0] in string.digits and filename[1] in string.digits :
                print filename            
                data = img.get_file_by_name(filename)
                if magnumber == 1 :
                    data = data[0x1d02:]
                elif magnumber == 2 and filename[0:2] == "03" :
                    data = vandalism_news.Unpacker(data).unpack()
                    data = data[0x1d01 - 12:]
                else :
                    data = vandalism_news.Unpacker(data).unpack()
                    data = data[0x1d01:]
                    
                if data[0x2ff] == "\xff" or data[0x2ff] == "\x00" :
                    outdata = ""
                    for i in xrange(0, len(data), 0x300) :
                        outdata += data[i:i+0x2d0]
                    data = outdata
                data = vandalism_news.translate(data)
                fname = magname + "-" + magnum + "-" + filename[0:2] + ".txt"
                #if os.path.isfile(fname) :
                #    print "File exists", fname
                #    fname += "_"
                of = open(fname, "wb")
                of.write(data)
                of.close()
