import binascii, sys

class Unpacker(object) :
    def __init__(self, data) :
        self.data = data
        self.debug = False
        
    def get_bits(self, numbits) :
        outbits = 0
        for i in xrange(numbits) :
            if self.bitrsv_numbits < 0 or self.bitrsv_numbits > 127 :
                if self.debug :
                    print "new char", binascii.b2a_hex(self.data[self.bitrsv_ptr])
                self.bitrsv_byte = ord(self.data[self.bitrsv_ptr])
                self.bitrsv_numbits = 7
                self.bitrsv_ptr -= 1
            outbits = outbits << 1
            if self.bitrsv_byte & 128 :
                outbits += 1
            self.bitrsv_byte = (self.bitrsv_byte << 1) % 256
            self.bitrsv_numbits -= 1

        if self.debug :
            print "outbits", numbits, outbits
        return outbits
        
    def unpack(self) :
        self.numbit_table = [3,4,5,6,7,7,8,9,4,4,5,6,7,9,0xa,0,0]
        self.offset_table = [0x000,0x008,0x018,0x038,0x078,0x0f8,0x178,0x278,0x000,0x010,0x020,0x040,0x080,0x100,0x300,0x700,0]
        
        self.bitrsv_ptr = len(self.data) - 14
        self.data = self.data[0] + self.data[len(self.data) - 13] + self.data[2:]
        self.offset_table[16] = ord(self.data[len(self.data) - 12]) * 256
        self.numbit_table[15] = ord(self.data[len(self.data) - 11])
        self.numbit_table[16] = ord(self.data[len(self.data) - 10])
        self.numbits_alt      = ord(self.data[len(self.data) - 8])
        self.unknown_byte     = ord(self.data[len(self.data) - 7])
        self.bitrsv_byte      = ord(self.data[len(self.data) - 6])
        self.bitrsv_numbits   = ord(self.data[len(self.data) - 5])
        
        #print self.numbit_table
        #print self.offset_table
        
        outdata = ""

        while True :
            if self.get_bits(1) == 1 :
                if self.get_bits(1) == 1 :
                    numchars = 1
                else :
                    bits = self.get_bits(2)
                    if bits < 2 :
                        numchars = bits + 2
                    elif bits == 2 :
                        numchars = self.get_bits(1) + 4
                    else :
                        bits = self.get_bits(3)
                        if bits != 7 :
                            numchars = bits + 6
                        else :
                            bits = self.get_bits(4)
                            if bits != 15 :
                                numchars = bits + 13
                            else :
                                numchars = self.get_bits(15)
                if self.debug :
                    print "numchars", numchars
                    print binascii.b2a_hex(self.data[self.bitrsv_ptr-numchars+1:self.bitrsv_ptr+1])
                outdata = self.data[self.bitrsv_ptr-numchars+1:self.bitrsv_ptr+1] + outdata
                self.bitrsv_ptr -= numchars
                if self.bitrsv_ptr < 0 :
                    break
            
            bit_add = 0
            if self.get_bits(1) == 1 :
                numchars = 2
            else :
                bit_add = 8
                if self.get_bits(1) == 0 :
                    numchars = 3
                else :
                    bits = self.get_bits(2)
                    if bits < 2 :
                        numchars = bits + 4
                    elif bits == 2 :
                        numchars = self.get_bits(2) + 6
                    else :
                        numchars = self.get_bits(5) + 10
                        if numchars == 15 :
                            numchars = self.get_bits(9)
                        elif numchars == 16 :
                            numchars = self.get_bits(5) + 42
                
            bits = self.get_bits(3) + bit_add
            #print "bits", bits, self.offset_table[bits], self.numbit_table[bits]
            offset = self.offset_table[bits] + self.get_bits(self.numbit_table[bits])
            if offset == self.unknown_byte :
                offset = self.offset_table[16] + self.get_bits(self.numbit_table[16])
            if self.debug :
                print "numchars", numchars, "offset", offset
            for i in xrange(numchars) :
                if self.debug :
                    print binascii.b2a_hex(outdata[offset]),
                outdata = outdata[offset] + outdata
            if self.debug :
                print

        if self.bitrsv_numbits != -1 :
            print "wrong numbits left", self.bitrsv_numbits
            #sys.exit()

        return outdata
