import binascii, sys

class NoMoreData(Exception) :
    pass

class Unpacker(object) :
    def __init__(self, data, only_first = False) :
        self.data = data
        self.only_first = only_first
        self.debug = False
        
    def get_byte(self) :
        if self.num_bytes :
            byte = ord(self.data[self.ptr])
            self.ptr += 1
            self.num_bytes -= 1
            return byte
        else :
            raise NoMoreData

    def get_bit(self) :
        #print "control byte", hex(self.control_byte)
        if self.control_byte & 128 :
            bit = 1
        else :
            bit = 0
        self.control_byte = (self.control_byte << 1) & 255
        if self.control_byte == 0 :
            self.control_byte = (self.get_byte() << 1) + 1
            if self.debug :
                print "   - new control byte", hex((self.control_byte - 1) >> 1 )
            if self.control_byte & 256 :
                bit = 1
                self.control_byte &= 255
            else :
                bit = 0
        return bit
            

    def unpack(self) :
        blocks = []
        self.ptr = 0
        
        while self.ptr < len(self.data) :
            self.num_bytes = 65536
            num_bytes_temp = self.get_byte() * 256 + self.get_byte()
            self.get_byte()
            self.get_byte()
            self.control_byte = self.get_byte()
            self.num_bytes = num_bytes_temp
            if self.debug :
                print self.num_bytes, len(self.data)
            
            a = 0
            self.outdata = ""
            
            try :
                while True :
                    a = self.get_bit()
                    if a != 0 :
                        if self.debug :
                            print "Getting new data"
                        while self.get_bit() :
                            a = (a << 1) + self.get_bit()
                            
                        if self.debug :
                            print "a", a
                        for i in xrange(a) :
                            self.outdata = chr(self.get_byte()) + self.outdata
                            if self.debug :
                                print binascii.b2a_hex(self.outdata[0]),
                        if self.debug :
                            print 
                    
                    a = self.get_bit()
                    if self.debug :
                        print "dsdd"
                    if a != 0 :
                        while self.get_bit() :
                            a = (a << 1) + self.get_bit()
                            if a & 128 :
                                break
                        if self.debug :
                            print "ddddaqw", hex(a)
                        x = 8
                    else :
                        if self.debug :
                            print "zerox"
                    
                        x = 0
                    a += 2
                    x += self.get_bit() * 4 + self.get_bit() * 2 + self.get_bit()
                    if self.debug :
                        print "x", x
                    
                    bar = 0
                    while True :
                        foo = [3,1,1,1,1,0,1,1,4,1,1,1,1,1,1,2][x]
                        if self.debug :
                            print "foo", foo
                        for i in xrange(foo) :
                            bar = (bar << 1) + self.get_bit()
                        if self.debug :                            
                            print hex(bar)
                        if x & 7 == 0 :
                            break
                        x -= 1
                        bar += 1

                    if self.debug :
                        print "bar", bar
                     
                    for i in xrange(a) :
                        try :
                            if self.debug :
                                print binascii.b2a_hex(self.outdata[bar + a - 1]),
                            self.outdata = self.outdata[bar + a - 1] + self.outdata
                        except IndexError :
                            print "Warning! Compression refered to area outside data!"
                            sys.exit()
                            self.outdata += "\x00"
                    if self.debug :
                        print
            except NoMoreData :
                blocks.append(self.outdata)
                if self.only_first :
                    break
                if self.debug :
                    print binascii.b2a_hex(self.outdata[0:4])
            
        return blocks
