import binascii, sys

class NoMoreData(Exception) :
    pass

class Unpacker(object) :
    def __init__(self, data, only_first = False) :
        self.data = data
        self.only_first = only_first
        self.debug = False
        
    def get_byte(self) :
        if self.ptr < len(self.data) :
            byte = ord(self.data[self.ptr])
            self.ptr += 1
            return byte
        else :
            raise NoMoreData

    def get_bit(self) :
        #print "control byte", hex(self.control_byte)
        if self.control_byte & 128 :
            bit = 1
        else :
            bit = 0
        self.control_byte = (self.control_byte << 1) & 255
        if self.control_byte == 0 :
            self.control_byte = (self.get_byte() << 1) + 1
            if self.debug :
                print "   - new control byte", hex((self.control_byte - 1) >> 1 )
            if self.control_byte & 256 :
                bit = 1
                self.control_byte &= 255
            else :
                bit = 0
        #print "get_bit", bit
        return bit
            

    def unpack(self) :
        self.ptr = 0
        self.control_byte = 0
        if self.debug :
            print len(self.data)
        
        self.outdata = ""
        try :
            while True :
                if self.get_bit() == 0 :
                    a = 1
                    while not self.get_bit() :
                        a = (a << 1) + self.get_bit()
                    if self.debug :
                        print "a", a
                    for i in xrange(a) :
                        self.outdata += chr(self.get_byte())
                        if self.debug :
                            print binascii.b2a_hex(self.outdata[-1]),
                    if self.debug :
                        print 
                a = 1
                if self.get_bit() :
                    while not self.get_bit() :
                        a = (a << 1) + self.get_bit()
                    a += 2
                    x = 0
                else :
                    a += 1
                    x = 1
                x = (x << 2) + (self.get_bit() << 1) + self.get_bit()
                if self.debug :
                    print "x", x

                aa = 0
                while True :
                    y = [4,3,3,3,4,2,2,2][x]
                    for i in xrange(y) :
                        aa = (aa << 1) + self.get_bit()
                        
                    x -= 1
                    if x == -1 or x == 3 :
                        break
                    aa += 1
                    if self.debug :
                        print "xx", x, aa
                        
                if self.debug :
                    print a, y, aa
                    
                for i in xrange(a) :
                    try :
                        if self.debug :
                            print binascii.b2a_hex(self.outdata[-(aa + a)]),
                        self.outdata += self.outdata[-(aa + a)]
                    except IndexError :
                        print "Warning! Compression refered to area outside data!"
                        sys.exit()
                        self.outdata += "\x00"
                if self.debug :
                    print
                    #print binascii.b2a_hex(self.outdata)
                 
        except NoMoreData :
            return self.outdata
