class Unpacker(object) :
    def __init__(self, data) :
        self.data = data
        self.xor = ord(data[0x42])
        self.controlbyte = ord(data[0x6a])
        self.index = 0x9e
        #print "bytes", hex(self.xor), hex(self.controlbyte)
        
    def get_byte(self) :
        byte = ord(self.data[self.index]) ^ self.xor
        self.index += 1
        return byte
        
    def unpack(self) :
        blocks = []
        block = ""
        while True :
            byte = self.get_byte()
            if byte != self.controlbyte :
                block += chr(byte)
            else :
                count = self.get_byte()
                if count >= 3 :
                    repeatbyte = self.get_byte()
                    block += chr(repeatbyte) * count
                elif count == 2 :
                    block += chr(controlbyte)
                else :
                    addr_lo = self.get_byte()
                    addr_hi = self.get_byte()
                    #print "start of new data block", hex(addr_lo + addr_hi * 256)
                    blocks.append(block)
                    block = ""
                    if addr_hi == 0 :
                        break
                        
        return blocks
