import sys, binascii

def unpack(data) :
    outdata = ""
    i = 0
    while i < len(data) :
        if data[i] == "\xc7" :
            count = ord(data[i + 1])
            if count == 0 :
                print "count is zero!"
                sys.exit()
            outdata += (data[i + 2] * count)
            i += 3
        elif data[i] == "\xa7" :
            count = ord(data[i + 1])
            if count == 0 :
                print "count is zero!"
                sys.exit()
            dist = ord(data[i + 2])
            for j in xrange(count) :
                outdata += outdata[-dist]
            i += 3
        elif data[i] == "\x87" :
            count = ord(data[i + 1])
            if count == 0 :
                print "count is zero!"
                sys.exit()
            dist = ord(data[i + 2]) + 256 * ord(data[i + 3])
            for j in xrange(count) :
                outdata += outdata[-dist]
            i += 4
        else :
            outdata += data[i]
            i += 1
            
    return outdata

def translate(data) :    
    outdata = ""
    line = ""
    for i in xrange(len(data)) :
        char_ord = ord(data[i])
        if char_ord >= 1 and char_ord <= 26 :
            line += chr(char_ord + 96)
        else :
            line += data[i]

        if i % 40 == 39 :
            outdata += line.rstrip() + "\n"
            line = ""
            
    return outdata